
from sets import Set
import time


class FPIRings:

    def __init__(self,pairs):
        self.ringOfRings = []
        #Delete duplicates
        pairs = list(Set(pairs))
        pairs.sort()
        self.pairs = pairs
            
        currencies = Set()
        for pair in pairs:
            currencies.add(pair[0:3])
            currencies.add(pair[3:6])
        currencies=list(currencies)
        currencies.sort()
        self.currencies = currencies

        totalCombinations = pow(2,len(pairs))
        print totalCombinations 

        matrix = []
        for m in xrange(len(currencies)):
            matrix.append([0]*len(currencies))
        
        for i in xrange(0,totalCombinations):
            t1 = i
            selectedPairs = []
            for pair in pairs:
                if (t1 & 1) == 1:
                    selectedPairs.append(pair);
                t1 = t1 >> 1
        
            self.clearMatrix(matrix)
            if len(selectedPairs) > 2:
                t1 = i
                for pair in selectedPairs:
                    x = currencies.index(pair[0:3])
                    y = currencies.index(pair[3:6])
                    matrix[x][y] = 1
                    matrix[y][x] = 1
    
                #matrix analysis
                rowsValid = True
                moreTheanZeroPairs = False
                for mRow in matrix:
                    rCount = mRow.count(1)
                    if rCount != 0 and rCount != 2:
                        rowsValid = False
                        break
                    else:
                        if rCount == 2:
                            moreThenZeroPairs = True

                #symbols in rings            
                if moreThenZeroPairs and rowsValid:
                    unpackSelPairs = []
                    for u in selectedPairs:
                        unpackSelPairs.append(u[0:3])
                        unpackSelPairs.append(u[3:6])
                                            
                    ring = [[selectedPairs[0],1]]
                    lastCurrency = selectedPairs[0][0:3]
                    finishCurrency = selectedPairs[0][3:6]
                    lastPairNumber = 0
                    found = True
                    ringFinished = False
                    while found and not ringFinished:
                        index = self.xIndex(unpackSelPairs[(lastPairNumber+1)*2:],lastCurrency)
                        if index == -1: #currency not found in second half
                            index = self.xIndex(unpackSelPairs[0:lastPairNumber*2],lastCurrency)
                            if index == -1: #currency not found in first half
                                found = False # open ring
                                break
                        else:
                            index = index+((lastPairNumber+1)*2) # different start of array
                        if index != 1: # last currency => second from the first pair
                            pairNumber = index/2
                            lastPairNumber = pairNumber
                            reverse = index%2
                            if reverse == 0:
                                lastCurrency = selectedPairs[pairNumber][3:6]
                            else:
                                lastCurrency = selectedPairs[pairNumber][0:3]
                            ring.append([selectedPairs[pairNumber],reverse])
                        else: # second currency from the first pair => finish currency
                            ringFinished = True
        
                    print self.printRing(ring)
                    self.ringOfRings.append(ring)



    def clearMatrix(self,ma):
        for i in xrange(len(ma)):
            for j in xrange(len(ma[i])):
                ma[i][j] = 0
                
    def mprint(self,ma):
        for xx in xrange(len(ma)):
            print ma[xx]
            
    def currencyMatches(self,current,last):
        if current[0:3].find(last[0:3]) == 0:
            return 1
        elif current[0:3].find(last[3:6]) == 0:
            return 2
        return 0
        
    def xIndex(self,array,p):
        try:
            return array.index(p)
        except ValueError:
            return -1
    
    def printRing(self,ring):
        out = ""
        for i in ring:
            if i[1] == 1: # Normal
                out += i[0]+"\t"
            else:
                out += "("+i[0]+")\t"
        return out.strip()

    def printRingOfRings(self):
        print self.pairs
        print self.currencies
        self.ringOfRings.sort()
        m = 0
        for i in self.ringOfRings:
            if len(i) > m:
                m = len(i)
        for i in range(3,m+1):
            for j in self.ringOfRings:
                if len(j) == i:
                    print self.printRing(j)
        
    
kreslik='AUD/JPY,AUD/USD,CAD/JPY,CHF/JPY,EUR/AUD,EUR/CAD,EUR/CHF,EUR/CZK,EUR/GBP,EUR/JPY,EUR/SEK,EUR/USD,GBP/CHF,GBP/JPY,GBP/USD,NZD/JPY,NZD/USD,USD/CAD,USD/CHF,USD/CZK,USD/DKK,USD/JPY,USD/NOK,USD/SEK'
p = kreslik.split(",")
p2 = []
for i in p:
    i = i[0:3]+i[4:]
    p2.append(i)
print p2


pairs = ('USDCHF','GBPUSD','EURUSD','USDJPY','AUDUSD','USDCAD',
         'EURGBP','EURCHF','EURJPY','GBPJPY','GBPCHF','EURAUD')
#pairs = ('USDCHF','GBPUSD','EURUSD','USDJPY')
#pairs = ('EURUSD','USDJPY','EURJPY','USDCHF','EURCHF')
time1 = time.time()
x=FPIRings(p2)
print "Seconds: ",time.time() - time1
x.printRingOfRings()
#print ">>>> SEP <<<<"
#print x.ringOfRings
